#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash
)]
#[serde(crate = "conjure_object::serde")]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct RunSearchState {
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::super::super::run::api::SortOptions>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "sort", skip_serializing_if = "Option::is_none", default)]
    sort: Option<Box<super::super::super::run::api::SortOptions>>,
    #[builder(default, into)]
    #[serde(rename = "groupBy", skip_serializing_if = "Option::is_none", default)]
    group_by: Option<Vec<super::ColumnId>>,
    #[builder(
        custom(type = super::super::super::run::api::SearchQuery, convert = Box::new)
    )]
    #[serde(rename = "query")]
    query: Box<super::super::super::run::api::SearchQuery>,
}
impl RunSearchState {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(query: super::super::super::run::api::SearchQuery) -> Self {
        Self::builder().query(query).build()
    }
    #[inline]
    pub fn sort(&self) -> Option<&super::super::super::run::api::SortOptions> {
        self.sort.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn group_by(&self) -> Option<&[super::ColumnId]> {
        self.group_by.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn query(&self) -> &super::super::super::run::api::SearchQuery {
        &*self.query
    }
}
